package com.lumberyard.graph.neo4j.plugins.communityclustering;

import org.neo4j.graphdb.GraphDatabaseService;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.Relationship;
import org.neo4j.tooling.GlobalGraphOperations;

public class GraphImporter {
    public DeltaModularityMatrix initDeltaModularityMatrixFrom(GraphDatabaseService graphDb) {
        Neo4jTestGraph.createGraph(graphDb);
        DeltaModularityMatrix q = new DeltaModularityMatrix();

        long m = 0;

        for (Relationship edge : GlobalGraphOperations.at(graphDb).getAllRelationships()) {
            m++;
        }

        for (Relationship edge : GlobalGraphOperations.at(graphDb).getAllRelationships()) {
            Node n0 = edge.getNodes()[0];
            Node n1 = edge.getNodes()[1];
            q.addEdge(n0.getId(), degree(n0), n1.getId(), degree(n1), m);
        }
        return q;
    }
    
    private int degree(Node n) {
        int degree = 0;

        for (Relationship edge : n.getRelationships()) {
            degree++;
        }

        return degree;
    }
}
