package com.lumberyard.graph.neo4j.plugins.communityclustering;

import java.util.Comparator;
import java.util.PriorityQueue;

public class MaxDeltaModularityHeap {
    private PriorityQueue<DeltaModularityJoin> maxHeap = new PriorityQueue<DeltaModularityJoin>(1,
            new Comparator<DeltaModularityJoin>() {

                @Override
                public int compare(DeltaModularityJoin join1, DeltaModularityJoin join2) {
                    return -1 * Double.compare(join1.deltaModularity, join2.deltaModularity);
                }

            });

    public MaxDeltaModularityHeap(DeltaModularityMatrix q) {
        for (long communityId : q.getAllRows()) {
            maxHeap.add(new DeltaModularityJoin(communityId, q.getMaxDeltaModularityForRow(communityId).getCommunityId(), 
                    q.getMaxDeltaModularityForRow(communityId).getDeltaModularity()));
        }
    }

    public DeltaModularityJoin getMaxDeltaModularityJoin() {
        return maxHeap.peek();
    }

    public class DeltaModularityJoin {
        public DeltaModularityJoin(long firstCommunity, long secondCommunity, double deltaModularity) {
            this.firstCommunity = firstCommunity;
            this.secondCommunity = secondCommunity;
            this.deltaModularity = deltaModularity;
        }

        public long firstCommunity;
        public long secondCommunity;
        public double deltaModularity;
    }
}
