package com.lumberyard.graph.neo4j.plugins.communityclustering;

import static org.junit.Assert.*;

import org.junit.Test;

public class MaxDeltaModularityHeapTest {
	@Test
	public void testConstruction_communitiesWithMaxDeltaModularityReturned() {
		DeltaModularityMatrix q = new DeltaModularityMatrix();

		q.addEdge(SimpleTestGraph.node1Id, SimpleTestGraph.node1Degree, SimpleTestGraph.node2Id, SimpleTestGraph.node2Degree, SimpleTestGraph.totalEdges);
		q.addEdge(SimpleTestGraph.node1Id, SimpleTestGraph.node1Degree, SimpleTestGraph.node3Id, SimpleTestGraph.node3Degree, SimpleTestGraph.totalEdges);
		
		MaxDeltaModularityHeap maxHeap = new MaxDeltaModularityHeap(q);
		
		assertEquals(SimpleTestGraph.node1Id, maxHeap.getMaxDeltaModularityJoin().firstCommunity);
		assertEquals(SimpleTestGraph.node2Id, maxHeap.getMaxDeltaModularityJoin().secondCommunity);
		assertEquals(0.125, maxHeap.getMaxDeltaModularityJoin().deltaModularity, 0.000001);
	}
}
