package com.lumberyard.graph.neo4j.plugins.communityclustering;

import org.neo4j.graphdb.GraphDatabaseService;
import org.neo4j.graphdb.Node;
import org.neo4j.graphdb.RelationshipType;
import org.neo4j.graphdb.Transaction;

public class Neo4jTestGraph {
	public static final String NODE1_NAME = "n1";
	public static final String NODE2_NAME = "n2";
	public static final String NODE3_NAME = "n3";
	public static final String NODE4_NAME = "n4";
	public static final String NODE5_NAME = "n5";
	public static final String NODE6_NAME = "n6";
	public static final String NODE7_NAME = "n7";
	public static final String NODE8_NAME = "n8";
	
	private enum RelTypes implements RelationshipType {
		X
	}
	
	public static void createGraph(GraphDatabaseService graphDb) {
		Transaction tx = graphDb.beginTx();
		
		Node n1, n2, n3, n4, n5, n6, n7, n8;
		
		try {
			n1 = graphDb.createNode();
			n2 = graphDb.createNode();
			n3 = graphDb.createNode();
			n4 = graphDb.createNode();
			n5 = graphDb.createNode();
			n6 = graphDb.createNode();
			n7 = graphDb.createNode();
			n8 = graphDb.createNode();
			
			n1.setProperty("name", NODE1_NAME);
			n2.setProperty("name", NODE2_NAME);
			n3.setProperty("name", NODE3_NAME);
			n4.setProperty("name", NODE4_NAME);
			n5.setProperty("name", NODE5_NAME);
			n6.setProperty("name", NODE6_NAME);
			n7.setProperty("name", NODE7_NAME);
			n8.setProperty("name", NODE8_NAME);
			
			n1.createRelationshipTo(n2, RelTypes.X);
			n1.createRelationshipTo(n3, RelTypes.X);
			n2.createRelationshipTo(n3, RelTypes.X);
			n3.createRelationshipTo(n4, RelTypes.X);
			n4.createRelationshipTo(n5, RelTypes.X);
			n5.createRelationshipTo(n6, RelTypes.X);
			n5.createRelationshipTo(n7, RelTypes.X);
			n6.createRelationshipTo(n7, RelTypes.X);
			n7.createRelationshipTo(n8, RelTypes.X);
			
			tx.success();
		} catch (Exception e) {
			tx.failure();
		} finally {
			tx.finish();
		}
	}
}
